Imports CommunityToolkit.Mvvm.Input
Imports System.Windows.Input

Public Class MainViewModel
    Inherits ViewModelBase
    Implements IMainViewModel

    Public Sub New(viewModelFactory As IViewModelFactory)
        MyBase.New(viewModelFactory)
        Me.CreateViewModel1Command = New RelayCommand(Sub() Me.CreateViewModel1CommandAction())
        Me.CreateViewModel2Command = New RelayCommand(Sub() Me.CreateViewModel2CommandAction())
    End Sub

    Private Sub CreateViewModel2CommandAction()
        Dim vm As IViewModel2 = Me._viewModelFactory.CreateViewModel(Of IViewModel2)
        vm.Age = 123
        Me.ContentViewModel = vm
    End Sub

    Private Sub CreateViewModel1CommandAction()
        Dim vm As IViewModel1 = Me._viewModelFactory.CreateViewModel(Of IViewModel1)
        vm.Name = "Hallo mtroja"
        Me.ContentViewModel = vm
    End Sub
    Private _contentViewModelBackingField As IViewModel
    Public Property ContentViewModel As IViewModel Implements IMainViewModel.ContentViewModel
        Get
            Return Me._contentViewModelBackingField
        End Get
        Set
            Me.SetProperty(Me._contentViewModelBackingField, Value)
        End Set
    End Property
    Public Property CreateViewModel1Command As ICommand Implements IMainViewModel.CreateViewModel1Command
    Public Property CreateViewModel2Command As ICommand Implements IMainViewModel.CreateViewModel2Command
End Class



Public Class MainViewModelDesignerSupport
    Implements IMainViewModel
    Public Property ContentViewModel As IViewModel = New ViewModel1DesignerSupport Implements IMainViewModel.ContentViewModel
    Public Property CreateViewModel1Command As ICommand Implements IMainViewModel.CreateViewModel1Command
    Public Property CreateViewModel2Command As ICommand Implements IMainViewModel.CreateViewModel2Command
End Class
